SystemOrganization addCategory: #'AjaxifiedComponents-Core'!

!WAAnchorTag methodsFor: '*ajaxifiedcomponents-core' stamp: 'JohanBrichau 9/5/2011 19:31'!
callbackWithAjaxUpdate: aNiladicValuable 
	aNiladicValuable argumentCount > 0 ifTrue: [ GRInvalidArgumentCount signal: 'Anchors expect a niladic callback.' ].
	self url: 'javascript:{', (canvas ajaxifiedUpdateScriptWith: aNiladicValuable) asJavascript,'}; void(null);'
		
! !

WAVisiblePresenterGuide subclass: #WADirtyPresenterGuide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AjaxifiedComponents-Core'!

!WADirtyPresenterGuide methodsFor: 'visiting' stamp: 'JohanBrichau 8/27/2011 10:44'!
visitPresenter: aPresenter
	| dirtyMode |
	dirtyMode := aPresenter visitingDirty.
	super visitPresenter: aPresenter.
	dirtyMode := aPresenter visitingDirty xor: dirtyMode.
	aPresenter childrenDo: [ :each | self visit: each ].
	dirtyMode ifTrue:[client visitingDirty: false]! !

WAVisitor subclass: #WAAjaxifiedUpdateScriptVisitor
	instanceVariableNames: 'script visitingDirty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AjaxifiedComponents-Core'!

!WAAjaxifiedUpdateScriptVisitor methodsFor: 'initialization' stamp: 'JohanBrichau 8/27/2011 10:36'!
initialize 
	super initialize.
	visitingDirty := false.! !

!WAAjaxifiedUpdateScriptVisitor methodsFor: 'accessing' stamp: 'JohanBrichau 8/26/2011 17:15'!
script
	^ script! !

!WAAjaxifiedUpdateScriptVisitor methodsFor: 'accessing' stamp: 'JohanBrichau 8/26/2011 17:15'!
script: anObject
	script := anObject! !

!WAAjaxifiedUpdateScriptVisitor methodsFor: 'visiting' stamp: 'JohanBrichau 8/27/2011 12:25'!
visitComponent: aComponent
	"Checks of a component was marked as dirty. If it was, we collect its update script and set our
	visiting mode to 'visitingDirty'. In that mode, we do not collect the script and simply unmark every
	components dirty flag"
	visitingDirty 
		ifTrue:[ aComponent isDirtyAndReset]
		ifFalse:[	aComponent isDirtyAndReset 
					ifTrue:[	aComponent scriptForAjaxifiedUpdateOn: script.  
							visitingDirty := true. ]]! !

!WAAjaxifiedUpdateScriptVisitor methodsFor: 'visiting' stamp: 'JohanBrichau 8/26/2011 17:34'!
visitDecoration: aComponent
	! !

!WAAjaxifiedUpdateScriptVisitor methodsFor: 'accessing' stamp: 'JohanBrichau 8/27/2011 10:45'!
visitingDirty: aBoolean
	visitingDirty := aBoolean! !

!WAHtmlCanvas methodsFor: '*ajaxifiedcomponents-core' stamp: 'JohanBrichau 8/27/2011 11:48'!
ajaxifiedUpdateScript
	^ self ajaxifiedUpdateScriptWith: nil! !

!WAHtmlCanvas methodsFor: '*ajaxifiedcomponents-core' stamp: 'JohanBrichau 8/27/2011 11:42'!
ajaxifiedUpdateScriptWith: aNiladicValuable  
	^ (self jQuery ajax script:[:s | 
					aNiladicValuable ifNotNil:[aNiladicValuable value].
					(WAVisiblePresenterGuide client: (WAAjaxifiedUpdateScriptVisitor new script: s)) start: self session presenter])! !

WAComponent subclass: #WAAjaxifiedComponent
	instanceVariableNames: 'markedAsDirty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AjaxifiedComponents-Core'!

!WAAjaxifiedComponent methodsFor: 'as yet unclassified' stamp: 'JohanBrichau 8/26/2011 17:32'!
id 
	self subclassResponsibility ! !

!WAAjaxifiedComponent methodsFor: 'as yet unclassified' stamp: 'JohanBrichau 8/26/2011 17:30'!
initialize 
	super initialize.
	markedAsDirty := false.! !

!WAAjaxifiedComponent methodsFor: 'as yet unclassified' stamp: 'JohanBrichau 8/27/2011 12:25'!
isDirtyAndReset 
	| result |
	result := markedAsDirty.
	markedAsDirty := false.
	^ result! !

!WAAjaxifiedComponent methodsFor: 'as yet unclassified' stamp: 'JohanBrichau 8/26/2011 17:30'!
markDirty 
	markedAsDirty := true! !

!WAAjaxifiedComponent methodsFor: 'as yet unclassified' stamp: 'JohanBrichau 8/26/2011 17:32'!
scriptForAjaxifiedUpdateOn: canvas
	canvas << ((canvas jQuery id: self id) replaceWith:[:r | r render: self])! !
